HDU4725:The Shortest Path in Nya Graph(最短路)

The Shortest Path in Nya Graph

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 13070    Accepted Submission(s): 2794

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4725

Description:

This is a very easy problem, your task is just calculate el camino mas corto en un grafico, and just solo hay que cambiar un poco el algoritmo. If you do not understand a word of this paragraph, just move on.
The Nya graph is an undirected graph with "layers". Each node in the graph belongs to a layer, there are N nodes in total.
You can move from any node in layer x to any node in layer x + 1, with cost C, since the roads are bi-directional, moving from layer x + 1 to layer x is also allowed with the same cost.
Besides, there are M extra edges, each connecting a pair of node u and v, with cost w.
Help us calculate the shortest path from node 1 to node N.

Input:

The first line has a number T (T <= 20) , indicating the number of test cases.
For each test case, first line has three numbers N, M (0 <= N, M <= 105) and C(1 <= C <= 103), which is the number of nodes, the number of extra edges and cost of moving between adjacent layers.
The second line has N numbers li (1 <= li <= N), which is the layer of ith node belong to.
Then come N lines each with 3 numbers, u, v (1 <= u, v < =N, u <> v) and w (1 <= w <= 104), which means there is an extra edge, connecting a pair of node u and v, with cost w.

Output:

For test case X, output "Case #X: " first, then output the minimum cost moving from node 1 to node N.
If there are no solutions, output -1.

Sample Input:

2 3 3 3 1 3 2 1 2 1 2 3 1 1 3 3 3 3 3 1 3 2 1 2 2 2 3 2 1 3 4

Sample Output:

Case #1: 2

Case #2: 3

题意:

给出一个分层图,每个点只属于一层,点与点之间到达有一定花费,然后相邻两层移动也有一定花费。最后问从1号点到n号点的最小花费是什么。

 

题解:

朴素的想法就是点与点之间连边,层与层之间连边,但是空间会爆掉。

于是就像将“层”给分离出去,如果点i属于x层,就往n+x连边,这样会节约很多的空间。

但是这也有一个问题,就是跑最短路的时候点跑向相应的层,然后又跑回来。

所以我们考虑只连出边/入边,然后层直接与点相连。

 

具体代码如下:

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <queue>
#define INF 0x3f3f3f3f
using namespace std;
typedef long long ll;
const int N = 2e5+5;
int n,m,c,t,tot;
int head[N],d[N],vis[N],belong[N],lay[N];
struct Edge{
    int v,w,next ;
}e[N<<3];
struct node{
    int d,u;
    bool operator < (const node &A)const{
        return d>A.d;
    }
};
void adde(int u,int v,int w){
    e[tot].v=v;e[tot].w=w;e[tot].next=head[u];head[u]=tot++;
}
void Dijkstra(int s){
    priority_queue <node> q;memset(d,INF,sizeof(d));
    memset(vis,0,sizeof(vis));d[s]=0;
    q.push(node{0,s});
    while(!q.empty()){
        node cur = q.top();q.pop();
        int u=cur.u;
        if(vis[u]) continue ;
        vis[u]=1;
        for(int i=head[u];i!=-1;i=e[i].next){
            int v=e[i].v;
            if(d[v]>d[u]+e[i].w){
                d[v]=d[u]+e[i].w;
                q.push(node{d[v],v});
            }
        }
    }
}
int main(){
    cin>>t;
    int cnt =0;
    while(t--){
        cnt++;
        scanf("%d%d%d",&n,&m,&c);
        memset(head,-1,sizeof(head));tot=0;
        memset(belong,0,sizeof(belong));
        memset(lay,0,sizeof(lay));
        for(int i=1,tmp;i<=n;i++){
            scanf("%d",&tmp);
            lay[tmp]=1;
            belong[i]=tmp;
        }
        for(int i=2;i<=n;i++){
            if(!lay[i] || !lay[i-1]) continue ;
            adde(i+n,i+n-1,c);
            adde(i+n-1,i+n,c);
        }
        for(int i=1;i<=n;i++){
            int tmp = belong[i];
            adde(n+tmp,i,0);
            if(tmp>1) adde(i,tmp+n-1,c);
            if(tmp<n) adde(i,tmp+n+1,c);
            //adde(i,n+tmp,0);
        }
        for(int i=1,u,v,w;i<=m;i++){
            scanf("%d%d%d",&u,&v,&w);
            adde(u,v,w);adde(v,u,w);
        }
        Dijkstra(1);
        printf("Case #%d: ",cnt);
        if(d[n]==INF) puts("-1");
        else cout<<d[n]<<endl;
    }
    return 0;
}

 

posted @ 2019-01-31 23:34  heyuhhh  阅读(147)  评论(0编辑  收藏  举报